# survtype

Package: survtype

Type: Package

Title: Subtype Identification with Survival Data

Description: Subtypes are defined as groups of samples that have distinct molecular and clinical features. Genomic data can be analyzed for discovering patient subtypes, associated with clinical data, especially for survival information. This package is aimed to identify subtypes that are both clinically relevant and biologically meaningful.

Version: 1.3.1

Date: 2019-12-18

Author: Dongmin Jung

Maintainer: Dongmin Jung <dmdmjung@gmail.com>

Depends: SummarizedExperiment, pheatmap, survival, survminer, clustvarsel, stats, utils

Suggests: maftools, scales, knitr

License: Artistic-2.0

biocViews: Software, StatisticalMethod, GeneExpression, Survival, Clustering, Sequencing, Coverage

NeedsCompilation: no

plot <- function(object, ...) UseMethod("plot")

plot.survtype <- function(object, ...)
{
  Time <- object$time
  Status <- object$status
  Group <- object$cluster
  surv.data <- data.frame(Time, Status, Group)
  fit <- object$fit
  if(!is.null(object$subset))
  {
    Time <- Time[object$subset]
    Status <- Status[object$subset]
    Group <- Group[object$subset]
    surv.data <- data.frame(Time, Status, Group)
  }
  ggsurvplot(fit, data = surv.data, ...)
}

maf2matrix <- function(maf, surv.data = NULL, sample.name = "Tumor_Sample_Barcode",
                       gene.name = "Hugo_Symbol", variant.type = "Variant_Classification")
{
  genes <- unique(maf[,gene.name])
  if(is.null(surv.data))
  {
    samples <- unique(maf[,sample.name])
  }
  else
  {
    samples <- intersect(unique(maf[,sample.name]),
                         rownames(surv.data))
  }
  # mutation matrix
  mutation <- matrix("", length(genes), length(samples))
  rownames(mutation) <- genes
  colnames(mutation) <- samples
  for(i in seq_len(ncol(mutation)))
  {
    index <- which(samples[i] == maf[,sample.name])
    sample.mut <- maf[index, c(gene.name, variant.type)]
    for(j in seq_len(nrow(sample.mut)))
    {
      index2 <- which(sample.mut[j, 1] == genes)
      mutation[index2, i] <- paste(mutation[index2, i], sample.mut[j, 2],
                                   ";", sep = "")
    }
  }
  mutation[order(rowSums(mutation != ""), decreasing = TRUE),]
}

Surv.survtype <- function(surv.data, time, status)
{
  Median <- median(surv.data[,time])
  Time <- surv.data[,time]
  Status <- surv.data[,status]
  Status.levels <- unique(Status)
  Status[Status == Status.levels[1]] <- 0
  Status[Status == Status.levels[2]] <- 1
  fit <- survfit(Surv(Time, Status) ~ 1)
  high.risk.prob <- 1 - summary(fit, times = Time)$surv/
    summary(fit, times = Median)$surv
  # median-cut
  Group <- NA
  Group <- ifelse(Time >= Median, "Low Risk", Group)
  Group <- ifelse(is.na(Group) == TRUE & Status == 1 & Time < Median,
                  "High Risk", Group)
  Group <- ifelse(is.na(Group) == TRUE & Status == 0 &
                    Time < Median & high.risk.prob < 0.5,
                  "Low Risk", Group)
  Group <- ifelse(is.na(Group) == TRUE & Status == 0 &
                    Time < Median & high.risk.prob > 0.5,
                  "High Risk", Group)
  fit <- survfit(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
  res <- survdiff(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
  print(res)
  output <- NULL
  output$n <- res$n
  output$obs <- res$obs
  output$exp <- res$exp
  output$var <- res$var
  output$chisq <- res$chisq
  output$call <- res$call
  output$cluster <- Group
  names(output$cluster) <- rownames(surv.data)
  output$time <- Time
  output$status <- Status
  output$surv.data <- surv.data
  output$fit <- fit
  class(output) <- c("survtype")
  output
}

Single.survgroup <- function(surv.data, time, status, single.gene, intermediate = FALSE,
                             group.names = c("High", "Intermediate", "Low"))
{
  if(!identical(rownames(na.omit(surv.data)), names(single.gene)))
  {
    cat("the row names of the survivla data and the names of the single gene are not identical \n")
    matched.samples <- intersect(rownames(na.omit(surv.data)), names(single.gene))
    if(length(matched.samples) == 0)
    {
      stop("no matched samples beween survival data and expression data")
    }
    surv.data <- surv.data[matched.samples,]
    single.gene <- single.gene[matched.samples]
  }
  cat(paste(nrow(surv.data)), "matched samples \n")
  
  Time <- surv.data[,time]
  Status <- surv.data[,status]
  Status.levels <- unique(Status)
  Status[Status == Status.levels[1]] <- 0
  Status[Status == Status.levels[2]] <- 1
  # midpoints
  single.gene <- as.numeric(single.gene)
  sort.single.gene <- sort(unique(single.gene))
  threshold <- approx(sort.single.gene, n = 2*length(sort.single.gene) - 1)$y
  threshold <- threshold [-which(threshold  %in% sort.single.gene)]
  # find p-values for every threshold
  if(intermediate == FALSE)
  {
    p.values <- 0
    chisq.stat <- 0
    for(i in seq_len(length(threshold)))
    {
      Group <- ifelse(single.gene > threshold[i], group.names[1], group.names[length(group.names)])
      SurvDiff <- survdiff(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
      chisq.stat[i] <- SurvDiff$chisq
      p.values[i] <- 1 - pchisq(SurvDiff$chisq, 1)
    }
    output <- NULL
    output$time <- Time
    output$status <- Status
    output$surv.data <- surv.data
    output$single.gene <- single.gene
    output$summary <- data.frame(cbind(threshold, chisq.stat, p.values)[order(p.values),])
    Group <- ifelse(single.gene > output$summary[1,1], group.names[1], group.names[length(group.names)])
    fit <- survfit(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
    output$cluster <- Group
    output$fit <- fit
  }
  if(intermediate == TRUE)
  {
    p.values <- matrix(NA, length(threshold), length(threshold))
    chisq.stat <- matrix(NA, length(threshold), length(threshold))
    num.Group1 <- matrix(NA, length(threshold), length(threshold))
    num.Group2 <- matrix(NA, length(threshold), length(threshold))
    num.Group3 <- matrix(NA, length(threshold), length(threshold))
    pb <- txtProgressBar(min = 0, max = length(threshold), style = 3)
    for(i in seq_len(length(threshold)))
    {
      for(j in seq_len(length(threshold)))
      {
        Group <- rep(group.names[2], length(single.gene))
        Group <- ifelse(single.gene > threshold[j], group.names[1], Group)
        Group <- ifelse(single.gene <= threshold[i], group.names[3], Group)
        num.Group1[i,j] <- sum(Group == group.names[1])
        num.Group2[i,j] <- sum(Group == group.names[2])
        num.Group3[i,j] <- sum(Group == group.names[3])
        Subset <- Group != group.names[2]
        SurvDiff <- survdiff(Surv(Time, Status) ~ Group, cbind(surv.data, Group),
                             subset = Subset)
        chisq.stat[i,j] <- SurvDiff$chisq
        p.values[i,j] <- 1 - pchisq(SurvDiff$chisq, 1)
      }
      Sys.sleep(0.01)
      setTxtProgressBar(pb, i)
    }
    cat("\n summarizing...")
    all.p.values <- unique(sort(p.values))
    index <- NULL
    for(i in seq_len(length(all.p.values)))
    {
      index <- rbind(index, which(p.values == all.p.values[i], arr.ind = TRUE))
    }
    
    output <- NULL
    output$time <- Time
    output$status <- Status
    output$surv.data <- surv.data
    output$summary <- data.frame(cbind(threshold[index[,2]], threshold[index[,1]],
                                       chisq.stat[index], p.values[index],
                                       num.Group1[index], num.Group2[index],
                                       num.Group3[index]))
    colnames(output$summary) <- c("threshold.high", "threshold.low", "chisq.stat",
                                  "p.values", "num.high", "num.intermediate", "num.low")
    Group <- rep(group.names[2], length(single.gene))
    Group <- ifelse(single.gene > output$summary[1,1], group.names[1], Group)
    Group <- ifelse(single.gene <= output$summary[1,2], group.names[3], Group)
    output$cluster <- Group
    Subset <- Group != group.names[2]
    output$subset <- Subset
    surv.data <- surv.data[Subset,]
    Time <- Time[Subset]
    Status <- Status[Subset]
    Group <- Group[Subset]
    fit <- survfit(Surv(Time, Status) ~ Group)
    output$fit <- fit
  }
  class(output) <- c("survtype")
  output
}

gene.clust <- function(object, K, ...)
{
  Group <- object$cluster
  annotation.col <- data.frame(as.factor(Group))
  colnames(annotation.col) <- "Group"
  rownames(annotation.col) <- colnames(object$exprs.data)
  annotation.colors <- list(Group = c(scales::hue_pal()(K)))
  names(annotation.colors$Group) <- seq_len(K)
  # assign clusters for genes
  Cluster <- cutree(object$heatmap$tree_row, K)
  for(i in seq_len(K))
  {
    pheatmap(object$exprs.data[Cluster == i, object$heatmap$tree_col$order],
             cluster_cols = FALSE, annotation_col = annotation.col,
             annotation_colors = annotation.colors, ...)
  }
  Cluster
}

## ----fig.align='center', message=FALSE, warning=FALSE, eval=TRUE--------------
library(survtype)
data(lung)
lung.survtype <- Surv.survtype(lung, time = "time", status = "status")
plot.survtype(lung.survtype, pval = TRUE)

## ----fig.align='center', message=FALSE, warning=FALSE, eval=TRUE--------------
data(ovarian)
ovarian.survtype <- Surv.survtype(ovarian, time = "futime", status = "fustat")
plot.survtype(ovarian.survtype, pval = TRUE)

## ----fig.align='center', message=FALSE, warning=FALSE, eval=FALSE-------------
# DLBCLgenes <- read.csv("https://doi.org/10.1371/journal.pbio.0020108.sd012", header = FALSE)
# DLBCLpatients <- read.csv("https://doi.org/10.1371/journal.pbio.0020108.sd013", header = FALSE)
# colnames(DLBCLpatients) <- c("time", "status")
# rownames(DLBCLpatients) <- colnames(DLBCLgenes)
# plot.survtype(Single.survgroup(DLBCLpatients, time = "time", status = "status", DLBCLgenes[1,]), pval = TRUE)
# 
# SE <- SummarizedExperiment(assays=SimpleList(expression = as.matrix(DLBCLgenes)))
# DLBCL.survtype <- Exprs.survtype(DLBCLpatients, time = "time", status = "status",
#                                  assay(SE), num.genes = 50,
#                                  scale = "row", gene.sel = TRUE,
#                                  clustering_method = "ward.D2",
#                                  show_colnames = FALSE)
# plot.survtype(DLBCL.survtype, pval = TRUE)

## ----fig.align='center', message=FALSE, warning=FALSE, eval=FALSE-------------
# library(SummarizedExperiment)
# library(TCGAbiolinks)
# query <- GDCquery(project = "TCGA-LUAD",
#                   data.category = "Gene expression",
#                   data.type = "Gene expression quantification",
#                   platform = "Illumina HiSeq",
#                   file.type  = "normalized_results",
#                   experimental.strategy = "RNA-Seq",
#                   legacy = TRUE)
# GDCdownload(query, method = "api")
# data <- GDCprepare(query)
# exprs.LUAD <- assay(data)
# # cancer only
# exprs.LUAD <- exprs.LUAD[,which(substr(colnames(exprs.LUAD), 14, 15) == "01")]
# clinic.LUAD <- GDCquery_clinic("TCGA-LUAD", "clinical")
# # stage I only
# clinic.LUAD <- clinic.LUAD[clinic.LUAD$tumor_stage %in% c("stage i", "stage ia", "stage ib"),]
# rownames(clinic.LUAD) <- clinic.LUAD[,1]
# clinic.LUAD <- clinic.LUAD[,c("days_to_last_follow_up", "vital_status")]
# clinic.LUAD$vital_status <- ifelse(clinic.LUAD$vital_status == "dead", 1, 0)
# # match TCGA ID
# colnames(exprs.LUAD) <- substr(colnames(exprs.LUAD), 1, 12)
# # filtering
# keep <- rowMeans(exprs.LUAD) > 500
# exprs.LUAD <- exprs.LUAD[keep,]
# # log2 transformation
# exprs.LUAD <- log2(exprs.LUAD + 1)
# # normalization
# exprs.LUAD <- quantile_normalization(exprs.LUAD)
# dim(exprs.LUAD)
# LUAD.survtype <- Exprs.survtype(clinic.LUAD, time = "days_to_last_follow_up",
#                                 status = "vital_status", exprs.LUAD,
#                                 num.genes = 100, scale = "row",
#                                 gene.sel = FALSE, clustering_method = "ward.D2",
#                                 show_colnames = FALSE)
# plot(LUAD.survtype, pval = TRUE, palette = c("#619CFF", "#F8766D"))
# gene.clust(LUAD.survtype, 2, scale = "row", clustering_method = "ward.D2",
#            show_colnames = FALSE)
# # VEGFA
# VEGFA.survgroup <- Single.survgroup(LUAD.survtype$surv.data,
#                                  time = "days_to_last_follow_up",
#                                  status = "vital_status",
#                                  LUAD.survtype$exprs.data["VEGFA",],
#                                  group.names = c("High Expression",
#                                                  "Low Expression"))
# plot(VEGFA.survgroup, title = "VEGFA", pval = TRUE)

## ----fig.align='center', message=FALSE, warning=FALSE, eval=TRUE--------------
library(maftools)
laml.maf <- system.file('extdata', 'tcga_laml.maf.gz', package = 'maftools', mustWork = TRUE)
laml.clin <- system.file('extdata', 'tcga_laml_annot.tsv', package = 'maftools', mustWork = TRUE)
laml.maf <- read.csv(laml.maf, sep = "\t")
laml.clinical.data <- read.csv(laml.clin, sep = "\t", row.names = 1)
index <- which(laml.clinical.data$days_to_last_followup == -Inf)
laml.clinical.data <- laml.clinical.data[-index,]
laml.clinical.data <- data.frame(laml.clinical.data)
laml.survgroup <- MAF.survgroup(laml.clinical.data, time = "days_to_last_followup",
                              status = "Overall_Survival_Status", laml.maf,
                              variants = "Missense_Mutation", num.genes = 10,
                              top.genes = 1, pval = TRUE)
head(laml.survgroup$summary)

quantile_normalization <- function(x)
{
  # x : expression profile
  Rownames <- rownames(x)
  Colnames <- colnames(x)
  y <- rowMeans(apply(x, 2, sort))
  qnorm <- apply(x, 2, function(x){quantile(y, ecdf(x)(x), type = 1)})
  dimnames(qnorm) <- list(Rownames, Colnames)
  qnorm
}

MAF.survgroup <- function(surv.data, time, status, maf, variants = NULL,
                          sample.name = "Tumor_Sample_Barcode", 
                          gene.name = "Hugo_Symbol",
                          variant.type = "Variant_Classification",
                          num.genes = 10, siginificant.genes = 1, ...)
{
  maf.matrix <- maf2matrix(maf, surv.data, sample.name = sample.name,
                           gene.name = gene.name, variant.type = variant.type)
  surv.data <- surv.data[colnames(maf.matrix),]
  if (!identical(rownames(surv.data), colnames(maf.matrix)))
    stop("the sample ID of survivla data and MAF is not identical")
  if(all(variants %in% unique(maf[,variant.type])) == FALSE)
    stop("some of variant types to be considered are not valid")
  Time <- surv.data[,time]
  Status <- surv.data[,status]
  Status.levels <- unique(Status)
  Status[Status == Status.levels[1]] <- 0
  Status[Status == Status.levels[2]] <- 1
  # find p-values for selected genes
  num.samples.with.variants <- 0
  p.values <- 0
  chisq.stat <- 0
  pattern <- ifelse(is.null(variants),
                    paste(unique(maf[,variant.type]), collapse = "|"),
                    paste(variants, collapse = "|"))
  for(i in seq_len(num.genes))
  {
    index <- grepl(pattern, maf.matrix[i,])
    num.samples.with.variants[i] <- sum(index)
    Group <- as.numeric(index)
    chisq.stat[i] <- survdiff(Surv(Time, Status) ~ Group,
                              cbind(surv.data, Group))$chisq
    p.values[i] <- ifelse(sum(index) == 0, NA,
                          1 - pchisq(chisq.stat[i], 1))
  }
  output <- NULL
  output$time <- Time
  output$status <- Status
  output$surv.data <- surv.data
  output$maf.matrix <- maf.matrix
  output$summary <- cbind(num.samples.with.variants, chisq.stat, p.values)
  rownames(output$summary) <- rownames(maf.matrix)[seq_len(num.genes)]
  output$summary <- data.frame(output$summary[order(p.values),])
  for(i in seq_len(siginificant.genes))
  {
    Group <- NULL
    Group <- ifelse(as.matrix(grepl(pattern, maf.matrix[rownames(output$summary)[i],])) == 1,
                    paste(rownames(output$summary)[i], "MT"),
                    paste(rownames(output$summary)[i], "WT"))
    fit <- survfit(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
    if(i == 1)
    {
      output$cluster <- Group[,1]
      output$fit <- fit
    }
    p <- ggsurvplot(fit, data = data.frame(Time, Status, Group), ...)
    print(p)
  }
  class(output) <- c("survtype")
  output
}

Exprs.survtype <- function(surv.data, time, status, exprs.data, K = 2,
                           num.genes = 100, gene.sel = FALSE,
                           gene.sel.opt = list(verbose = FALSE), ...)
{
  exprs.data <- data.frame(exprs.data)
  if(!identical(rownames(na.omit(surv.data)), colnames(exprs.data)))
  {
    cat("the row names of the survivla data and the column names of the expression data are not identical \n")
    matched.samples <- intersect(rownames(na.omit(surv.data)), colnames(exprs.data))
    if(length(matched.samples) == 0)
    {
      stop("no matched samples beween survival data and expression data")
    }
    surv.data <- surv.data[matched.samples,]
    exprs.data <- exprs.data[,matched.samples]
  }
  cat(paste(nrow(surv.data)), "matched samples")
  
  Time <- surv.data[,time]
  Status <- surv.data[,status]
  Status.levels <- unique(Status)
  Status[Status == Status.levels[1]] <- 0
  Status[Status == Status.levels[2]] <- 1
  # scoring variables
  scores <- apply(exprs.data, 1, function(x) coxph(Surv(Time, Status) ~ as.numeric(x))$score)
  names(scores) <- rownames(exprs.data)
  variables <- names(head(sort(scores, decreasing = TRUE), min(num.genes, length(scores))))
  # variable selection
  if(gene.sel == TRUE)
  {
    clust.var.sel <- do.call(clustvarsel, 
                             c(list(t(exprs.data[variables,]), K), gene.sel.opt))
    variables <- variables[clust.var.sel$subset]
  }
  pheatmap.silent <- pheatmap(exprs.data[variables,], silent = TRUE, ...)
  # assign clusters for samples
  Group <- cutree(pheatmap.silent$tree_col, K)
  fit <- survfit(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
  # heatmap
  annotation.col <- data.frame(as.factor(Group))
  colnames(annotation.col) <- "Group"
  rownames(annotation.col) <- colnames(exprs.data)
  annotation.colors <- list(Group = c(scales::hue_pal()(K)))
  names(annotation.colors$Group) <- seq_len(K)
  pheatmap(exprs.data[variables,], annotation_col = annotation.col,
           annotation_colors = annotation.colors, ...)
  res <- survdiff(Surv(Time, Status) ~ Group, cbind(surv.data, Group))
  print(res)
  output <- NULL
  output$n <- res$n
  output$obs <- res$obs
  output$exp <- res$exp
  output$var <- res$var
  output$chisq <- res$chisq
  output$call <- res$call
  output$fit <- fit
  output$cluster <- Group
  names(output$cluster) <- rownames(surv.data)
  output$time <- Time
  output$status <- Status
  output$surv.data <- surv.data
  output$exprs.data <- exprs.data[variables,]
  output$heatmap <- pheatmap.silent
  class(output) <- c("survtype")
  output
}

\name{quantile_normalization}
\alias{quantile_normalization}

\title{
Normalize a gene expression profile
}
\description{
Normalize expression data using quantile normalization
}
\usage{
quantile_normalization(x)
}

\arguments{
  \item{x}{
an expression profile
}
}


\value{
a normalized matrix
}


\author{
Dongmin Jung
}



\examples{
set.seed(1)
nrows <- 10
ncols <- 5
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
normalized.matrix <- quantile_normalization(counts)
}

\name{Single.survgroup}
\alias{Single.survgroup}

\title{
Patient group identification via survival information and expression of a single gene
}
\description{
All midpoints of the expression level or real-valued statistic are investigated to find the best threshold giving the most significant difference between two groups. Any patients having the value greater than the best cutoff are assigned as the "high-score" class. Otherwise, the others belong to the "low-score" class.
}
\usage{
Single.survgroup(surv.data, time, status, single.gene, intermediate = FALSE,
                 group.names = c("High", "Intermediate", "Low"))
}

\arguments{
  \item{surv.data}{
survival data
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{single.gene}{
expression level of a single gene
}
  \item{intermediate}{
a logical value indicating whether or not the intermediate class is considered (default: FALSE)
}
  \item{group.names}{
the name of clusters for "high-score", "intermediate-score", and "low-score" classes (defult: "High", "Intermediate", "Low")
}
}



\value{
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{surv.data}{
survival data
}
  \item{score}{
a vector of scores
}
  \item{summary}{
a list of thresholds, chi-squared statistics and p-values
}
  \item{cluster}{
a vector of clusters to which samples are assigned
}
  \item{fit}{
fitted survival curves
}
}



\author{
Dongmin Jung
}



\seealso{
survival::Surv, survival::survfit, survival::survdiff
}

\examples{
set.seed(1)
nrows <- 1
ncols <- nrow(ovarian)
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
colnames(counts) <- paste("X", 1:ncols, sep = "")
rownames(ovarian) <- paste("X", 1:ncols, sep = "")
Single.ovarian <- Single.survgroup(ovarian, time = "futime", status = "fustat", counts[1,])
plot(Single.ovarian, pval = TRUE)
}

\name{Exprs.survtype}
\alias{Exprs.survtype}

\title{
Sample subtype identification via survival information and gene expression data
}
\description{
For discovery of subtypes of samples that are both clinically relevant and biologically meaningful, the Cox regession model and hierarchical clustering are combined. 
}
\usage{
Exprs.survtype(surv.data, time, status, exprs.data, K = 2, num.genes = 100,
               gene.sel = FALSE, gene.sel.opt = list(verbose = FALSE), ...)
}

\arguments{
  \item{surv.data}{
survival data
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{exprs.data}{
expression data
}
  \item{K}{
the number of clusters (default: 2)
}
  \item{num.genes}{
the number of top genes based on the Cox score, before variable selection (default: 100)
}
  \item{gene.sel}{
a logical value indicating whether or not gene selection for clustring is applied (default: FALSE)
}
  \item{gene.sel.opt}{
a list of options for the gene selection function "clustvarsel". "verbose" is set to FALSE as default.
}
  \item{...}{
additional parameters for the "pheatmap"
}
}



\value{
  \item{n}{
the number of subjects in each group
}
  \item{obs}{
the weighted observed number of events in each group
}
  \item{exp}{
the weighted expected number of events in each group
}
  \item{chisq}{
the chi-squared statistic for a test of equality
}
  \item{call}{
the matched call
}
  \item{fit}{
fitted survival curves
}
  \item{cluster}{
a vector of integers indicating the cluster to which each sample is assigned
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{surv.data}{
survival data
}
  \item{exprs.data}{
expression data
}
}


\references{
Bair, E., & Tibshirani, R. (2004). Semi-supervised methods to predict patient survival from gene expression data. PLoS biology, 2(4), e108.
}


\author{
Dongmin Jung
}



\seealso{
survival::Surv, survival::survfit, survival::survdiff, survival::coxph, clustvarsel::clustvarsel, pheatmap::pheatmap
}

\examples{
set.seed(1)
nrows <- 5
ncols <- nrow(ovarian)
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
colnames(counts) <- paste("X", 1:ncols, sep = "")
rownames(ovarian) <- paste("X", 1:ncols, sep = "")
SE <- SummarizedExperiment(assays = SimpleList(counts = counts))
ovarian.survtype <- Exprs.survtype(ovarian, time = "futime", status = "fustat",
                                 assay(SE), num.genes = 2, scale = "row",
                                 clustering_method = "ward.D2")
plot(ovarian.survtype, pval = TRUE)
}

\name{plot.survtype}
\alias{plot.survtype}
\alias{plot}

\title{
Plot of survival curves of sample subtypes
}
\description{
Survival curves for subtypes of samples can be drawn.
}
\usage{
\method{plot}{survtype}(object, ...)
}

\arguments{
  \item{object}{
object of class "survtype"
}
  \item{...}{
additional parameters for the "ggsurvplot"
}
}


\value{
Survival curves
}


\author{
Dongmin Jung
}



\seealso{
survminer::ggsurvplot
}

\examples{
data(ovarian)
ovarian.survtype <- Surv.survtype(ovarian, time = "futime", status = "fustat")
plot(ovarian.survtype, pval = TRUE)
}

\name{MAF.survgroup}
\alias{MAF.survgroup}

\title{
Patient group identification via survival data and mutation annotation information
}
\description{
The groups of patients are identified according to whether the varints exist on a single gene. Survival difference between patients with and without mutations is compared.
}
\usage{
MAF.survgroup(surv.data, time, status, maf, variants = NULL,
              sample.name = "Tumor_Sample_Barcode", gene.name = "Hugo_Symbol",
              variant.type = "Variant_Classification", num.genes = 10,
              siginificant.genes = 1, ...)
}

\arguments{
  \item{surv.data}{
survival data
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{maf}{
a MAF file
}
  \item{variants}{
types of varints on a single gene for mutated samples. samples with any mutations, defined as mutated samples by default.
}
  \item{sample.name}{
the column name containing sample names (defult: "Tumor_Sample_Barcode")
}
  \item{gene.name}{
the column name containing gene names  (defult: "Hugo_Symbol")
}
  \item{variant.type}{
the column name containing variant types  (defult: "Variant_Classification")
}
  \item{num.genes}{
the number of top genes based on the number of mutated genes (default: 10)
}
  \item{siginificant.genes}{
the number of top genes based on the statistical siginificance of mutated genes (default: 1)
}
  \item{...}{
additional parameters for the "ggsurvplot" for the statistically siginificant genes
}
}



\value{
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{surv.data}{
survival data
}
  \item{maf.matrix}{
a mutation matrix
}
  \item{summary}{
a list of number of samples with variants, chi-squared statistics and p-values
}
  \item{cluster}{
a vector of integers indicating the cluster to which each sample is assigned, for the most significant gene
}
  \item{fit}{
fitted survival curves, for the most significant gene
}
}

\author{
Dongmin Jung
}



\seealso{
survival::Surv, survival::survfit, survival::survdiff, survminer::ggsurvplot
}

\examples{
library(maftools)
laml.maf <- system.file('extdata', 'tcga_laml.maf.gz', package = 'maftools', mustWork = TRUE)
laml.clin <- system.file('extdata', 'tcga_laml_annot.tsv', package = 'maftools', mustWork = TRUE)
laml.maf <- read.csv(laml.maf, sep = "\t")
laml.clinical.data <- read.csv(laml.clin, sep = "\t", row.names = 1)
index <- which(laml.clinical.data$days_to_last_followup == -Inf)
laml.clinical.data <- laml.clinical.data[-index,]
laml.clinical.data <- data.frame(laml.clinical.data)
laml.survgroup <- MAF.survgroup(laml.clinical.data, time = "days_to_last_followup",
                                status = "Overall_Survival_Status", laml.maf,
                                num.genes = 3, siginificant.genes = 1,
                                pval = TRUE)
}

\name{maf2matrix}
\alias{maf2matrix}

\title{
Convert a MAF file to a mutation matrix
}
\description{
Create a mutation matrix using variant types
}
\usage{
maf2matrix(maf, surv.data = NULL, sample.name = "Tumor_Sample_Barcode",
           gene.name = "Hugo_Symbol", variant.type = "Variant_Classification")
}

\arguments{
  \item{maf}{
a MAF file
}
  \item{surv.data}{
survival data for sample names (default: NULL)
}
  \item{sample.name}{
the column name containing sample names (defult: "Tumor_Sample_Barcode")
}
  \item{gene.name}{
the column name containing gene names  (defult: "Hugo_Symbol")
}
  \item{variant.type}{
the column name containing variant types  (defult: "Variant_Classification")
}
}


\value{
a mutation matrix
}


\author{
Dongmin Jung
}



\examples{
laml.maf <- system.file("extdata", "tcga_laml.maf.gz", package = "maftools")
laml.maf <- read.csv(laml.maf, sep = "\t")
laml.mat <- maf2matrix(laml.maf)
}

\name{gene.clust}
\alias{gene.clust}

\title{
Plots of the heatmap for each cluster of expression data
}
\description{
Heatmaps of clustered genes for subtypes of samples can be drawn.
}
\usage{
gene.clust(object, K, ...)
}

\arguments{
  \item{object}{
the result of "Exprs.survtype"
}
  \item{K}{
the number of clusters
}
  \item{...}{
additional parameters for the "pheatmap"
}
}


\value{
Heatmap for each cluster
}


\author{
Dongmin Jung
}



\seealso{
pheatmap::pheatmap
}

\examples{
set.seed(1)
nrows <- 5
ncols <- nrow(ovarian)
counts <- matrix(runif(nrows * ncols, 1, 1e4), nrows)
colnames(counts) <- paste("X", 1:ncols, sep = "")
rownames(ovarian) <- paste("X", 1:ncols, sep = "")
SE <- SummarizedExperiment(assays = SimpleList(counts = counts))
ovarian.survtype <- Exprs.survtype(ovarian, time = "futime", status = "fustat",
                                 assay(SE), num.genes = 5, scale = "row",
                                 clustering_method = "ward.D2")
plot(ovarian.survtype, pval = TRUE)
gene.clust(ovarian.survtype, 2, scale = "row", clustering_method = "ward.D2")
}

\name{Surv.survtype}
\alias{Surv.survtype}

\title{
Sample subtype identification via survival information
}
\description{
Any patient who lived longer than the median was considered to be a "low-risk" patient, and any patient that lived less than the median was considered to be a "high-risk"" patient. In this manner, we assigned a class label to each observation.
For censored data, we can estimate the probability that each censored observation belongs to the "low-risk" and "high-risk" classes, respectively.
}
\usage{
Surv.survtype(surv.data, time, status)
}

\arguments{
  \item{surv.data}{
survival data
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
}


\value{
  \item{n}{
the number of subjects in each group
}
  \item{obs}{
the weighted observed number of events in each group
}
  \item{exp}{
the weighted expected number of events in each group
}
  \item{chisq}{
the chi-squared statistic for a test of equality
}
  \item{call}{
the matched call
}
  \item{cluster}{
a vector of clusters to which samples are assigned
}
  \item{time}{
survival time
}
  \item{status}{
status indicator
}
  \item{surv.data}{
survival data
}
  \item{fit}{
fitted survival curves
}
}


\references{
Bair, E., & Tibshirani, R. (2004). Semi-supervised methods to predict patient survival from gene expression data. PLoS biology, 2(4), e108.
}


\author{
Dongmin Jung
}



\seealso{
survival::Surv, survival::survfit, survival::survdiff
}

\examples{
data(ovarian)
ovarian.survtype <- Surv.survtype(ovarian, time = "futime", status = "fustat")
}
